#!/usr/bin/env node
var TIM_FOLDER = '/opt/timmanager/';
var execSync = require('child_process').execSync;

var getPID = function(app) {
	var result = -1;
	var tempData = execSync('ps -ef | grep -v grep | grep ' + app + ' | awk \'{print $2, $9}\'').toString();
	tempData = tempData.split('\n');
	tempData.forEach(function(item) {
		var itemArr = item.split(" ");
		if (itemArr.length == 2) {
			var name = itemArr[1].substring(itemArr[1].lastIndexOf("/") + 1);
			if (name == app)
				result = itemArr[0];
		}
	});
	return result;
}

var count = 0;
function service() {
	count++;
	check();
	if (count < 11) {
		setTimeout(service, 5000);
	}
}

function check() {
	var manager = getPID('timmanager');
	console.log("PID : " + manager);
	if (manager > -1) {
		return;
	} else {
		console.log("Start TIM Manager.");
		try {
			execSync('export DISPLAY=:0.0 && gnome-terminal -e ' + TIM_FOLDER + 'bin/timmanager > ' + TIM_FOLDER + 'Log/err.log 2>&1');
		} catch (e) {
			console.log("Failed to start gnome-terminal. Use screen.");
			try {
				execSync('screen -s timmanager -dmS timmanager > ' + TIM_FOLDER + 'Log/err2.log 2>&1 &');
			} catch (e) {
				console.log("Failed to start screen. Need to install screen. \n Usage : sudo apt-get install screen");
			}
		}
	}
}

console.log("Start TIM Service.");
service();